org.apache.commons.math3.stat.descriptive.moment

## Class SecondMoment

- java.lang.Object
- - org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic
  - - org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic
    - - org.apache.commons.math3.stat.descriptive.moment.FirstMoment
      - - org.apache.commons.math3.stat.descriptive.moment.SecondMoment

- All Implemented Interfaces:
    Serializable, StorelessUnivariateStatistic, UnivariateStatistic, MathArrays.Function
  Direct Known Subclasses:
    ThirdMoment

      public class SecondMoment
      extends FirstMoment
      implements Serializable

  Computes a statistic related to the Second Central Moment. Specifically, what is computed is the sum of squared deviations from the sample mean.

  The following recursive updating formula is used:

  Let

  - dev = (current obs - previous mean)
  - n = number of observations (including current obs)
  Then

  new value = old value + dev^2 * (n -1) / n.

  Returns `Double.NaN` if no data values have been added and returns `0` if there is just one value in the data set.

  Note that this implementation is not synchronized. If multiple threads access an instance of this class concurrently, and at least one of the threads invokes the `increment()` or `clear()` method, it must be synchronized externally.

  Version:
    $Id: SecondMoment.java 1416643 2012-12-03 19:37:14Z tn $
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected double` | `m2` second moment of values that have been added
    `private static long` | `serialVersionUID` Serializable version identifier

    - ### Fields inherited from class org.apache.commons.math3.stat.descriptive.moment.FirstMoment

      `dev, m1, n, nDev`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SecondMoment()` Create a SecondMoment instance
    `SecondMoment(SecondMoment original)` Copy constructor, creates a new `SecondMoment` identical to the `original`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clears the internal state of the Statistic
    `SecondMoment` | `copy()` Returns a copy of the statistic with the same internal state.
    `static void` | `copy(SecondMoment source, SecondMoment dest)` Copies source to dest.
    `double` | `getResult()` Returns the current value of the Statistic.
    `void` | `increment(double d)` Updates the internal state of the statistic to reflect the addition of the new value.

    - ### Methods inherited from class org.apache.commons.math3.stat.descriptive.moment.FirstMoment

      `copy, getN`

    - ### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractStorelessUnivariateStatistic

      `equals, evaluate, evaluate, hashCode, incrementAll, incrementAll`

    - ### Methods inherited from class org.apache.commons.math3.stat.descriptive.AbstractUnivariateStatistic

      `evaluate, getData, getDataRef, setData, setData, test, test, test, test`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### serialVersionUID

          private static final long serialVersionUID

      Serializable version identifier
      See Also:
        Constant Field Values

    - #### m2

          protected double m2

      second moment of values that have been added

  - ### Constructor Detail

    - #### SecondMoment

          public SecondMoment()

      Create a SecondMoment instance

    - #### SecondMoment

          public SecondMoment(SecondMoment original)
                       throws NullArgumentException

      Copy constructor, creates a new `SecondMoment` identical to the `original`
      Parameters:
        `original` - the `SecondMoment` instance to copy
      Throws:
        `NullArgumentException` - if original is null

  - ### Method Detail

    - #### increment

          public void increment(double d)

      Updates the internal state of the statistic to reflect the addition of the new value.
      Specified by:
        `increment` in interface `StorelessUnivariateStatistic`
      Overrides:
        `increment` in class `FirstMoment`
      Parameters:
        `d` - the new value.

    - #### clear

          public void clear()

      Clears the internal state of the Statistic
      Specified by:
        `clear` in interface `StorelessUnivariateStatistic`
      Overrides:
        `clear` in class `FirstMoment`

    - #### getResult

          public double getResult()

      Returns the current value of the Statistic.
      Specified by:
        `getResult` in interface `StorelessUnivariateStatistic`
      Overrides:
        `getResult` in class `FirstMoment`
      Returns:
        value of the statistic, `Double.NaN` if it has been cleared or just instantiated.

    - #### copy

          public SecondMoment copy()

      Returns a copy of the statistic with the same internal state.
      Specified by:
        `copy` in interface `StorelessUnivariateStatistic`
      Specified by:
        `copy` in interface `UnivariateStatistic`
      Overrides:
        `copy` in class `FirstMoment`
      Returns:
        a copy of the statistic

    - #### copy

          public static void copy(SecondMoment source,
                  SecondMoment dest)
                           throws NullArgumentException

      Copies source to dest.

      Neither source nor dest can be null.

      Parameters:
        `source` - SecondMoment to copy
        `dest` - SecondMoment to copy to
      Throws:
        `NullArgumentException` - if either source or dest is null

Copyright (c) 2003-2013 Apache Software Foundation